<?php
/**
 * Main HTML page of codetabs plugins
 * Page : Home
 */






/* BIEN KHOI TAO VA SHORTCUT BAN DAU
----------------------------------------------------------------------------- */
$opts_main = get_option('codetabs');
$a_tabs    = isset($opts_main['id']) ? $opts_main['id'] : NULL;






/* THOI GIAN CAP NHAT : SETUP DE DOC DE DANG
----------------------------------------------------------------------------- */
function ct14time_human_timing($a_tabs) {
        
    // Bien khoi tao
    $time_human = array();
    $time_cur   = time();
    $tokens     = array(
        31536000  => 'year',
        2592000   => 'month',
        86400     => 'day',
        3600      => 'hour',
        60        => 'minute',
        1         => 'second'
    );

    // Vong lap : setup tat ca ca'c tabs
    foreach( $a_tabs as $key => $value ) {
        $time_update = $a_tabs[$key]['time-update'];
        $duration    = $time_cur - $time_update;

        foreach( $tokens as $unit => $text ) {
            if( $duration >= $unit ) {
                $list_count = floor($duration / $unit);
                $time_human[$key] = $list_count .' '. ($list_count > 1 ? $text .'s' : $text);
                break;
            }
        }
    }
    return $time_human;
}
// Tao ma?ng danh sach chua' thoi gian moi vua cap nhat
$time_human = ct14time_human_timing($a_tabs);






/* PHAN CHIA TABS THANH NHUNG PHAN NHO
----------------------------------------------------------------------------- */
$count_tabs_of_group = 10;  // SO TABS TRONG 1 SLIDE
$count_tabs = count($a_tabs);
$group_tabs = array( 0 => array() );

// Vong lap copy tat ca tabs sang 'group_tabs'
$num_loop = $num_group = 0;
foreach ($a_tabs as $tabs_id => $tabs_info) {
    
    // Neu so luong cua tabs toi so' luo.ng cho phep --> reset lai bo diem
    if( $num_loop == $count_tabs_of_group ) {
        $num_loop = 0;
        $num_group++;
        $group_tabs[$num_group] = array();
    }

    // Gian thong tin cua tabs hien tai vao` ma?ng
    $group_tabs[$num_group][$num_loop] = $tabs_info;
    // Tang so luong bo. diem tabs
    $num_loop++;
}

// Setup others
$count_group_tabs = count($group_tabs);
$is_onegroup = $count_group_tabs == 1;
?>


<!-- CODETABS wrap content -->
<div class="ct14page ct14page-home">
    <input type="hidden" name="ct14page" value="home">
    <input type="hidden" name="ct14count-tabs-of-group" value="<?php echo $count_tabs_of_group; ?>">
    
    <!-- HEADER SECTION - begin
    ////////////////////////////////////////////////////////////////////////// -->
    <div class="ct14part-header ct14clear-a">

        <!-- CODETABS LOGO -->
        <a class="ct14logo" href="admin.php?page=codetabs" title="Home">CODETABS</a>
        
        <!-- HEADER CONTROL -->
        <div class="ct14control-header">
            <a  class="ct14control-btn ct14control-delete"
                href="#ct14id-delete"
                title="Delete tabs"
                data-options='{ "height": 180, "classMore": "ct14no-bg", "isBtnClose": false, "isLinkOpen": false, "isOverClose": false }'>
                <i class="ct14i24-delete"></i>
                <span class="ct14control-select-all">Select All</span>
            </a>

            <a class="ct14control-btn ct14control-imex ct14ip24-transfer" title="Import/Export tabs"></a>
        </div>

    </div>
    <!-- HEADER SECTION - end
    ////////////////////////////////////////////////////////////////////////// -->







    <!-- IMPORT EXPORT DATA - begin
    ////////////////////////////////////////////////////////////////////////// -->
    <div class="ct14part-imex">

        <!-- IMPORT NAME -->
        <h2 class="ct14part-name">IMPORT</h2>

        <!-- IMPORT SECTION - begin -->
        <div class="ct14import">
        <div class="ct14import-inner">
                
                <!-- Button select file -->
                <input type="file" class="ct14import-input-file">
                <a class="ct14import-select ct14btn-large ct14btn-blue ">Choose file</a>

                <!-- Button upload data -->
                <a class="ct14import-upload ct14deactived ct14tabs-btn-ajax">
                    <span class="ct14btn-large ct14btn-red ct14tabs-btn-first">Import data</span>
                    <span
                        class="ct14tabs-btn-last"
                        data-ct14svg='{"name": "loader-puff", "width": 55, "height": 55, "strokeWidth": 2, "color": "#dd0000" }'
                    ></span>
                </a>

                <!-- Message output -->
                <div class="ct14import-output"></div>
        </div>
        </div>
        <!-- IMPORT SECTION - begin -->
        


        <!-- EXPORT SECTION - begin -->
        <div class="ct14export">

            <!-- Export name -->
            <h2 class="ct14part-name">EXPORT</h2>

            <div class="ct14export-control">
                <!-- Button select all -->
                <a class="ct14btn ct14export-select-all">Select all</a>

                <!-- Button save as file -->
                <form class="ct14export-download" method="POST">
                    <input type="hidden" name="action" value="ct14export-download">
                    <input class="ct14export-info" type="hidden" name="ct14info" value="">

                    <input type="submit" class="ct14export-submit" name="submit" value="Download">
                    <a class="ct14btn ct14export-download-btn ct14deactived">Download</a>
                </form>
            </div>
        </div>
        <!-- EXPORT SECTION - end -->
    </div>
    <!-- IMPORT EXPORT DATA - end
    ////////////////////////////////////////////////////////////////////////// -->



    


    <!-- GALLERY - begin
    ////////////////////////////////////////////////////////////////////////// -->
    <?php if(!$is_onegroup) : ?>
    <!-- GALLERY ITEM WITH TABS - begin -->
    <div class="ct14ga ct14container">

        <div
            class="ct11 ct14tabs-alltabs"
            data-tabs='{
                "isAutoInit": true,
                "idBegin": "end",
                "speed" : 300,
                "isSwipe": true, "margin": 100,
                "pag": {"pos": "bottom", "align": "end"}
            }'
        >

        <?php
        // Setup tren moi group-tabs
        for( $num_group = 0; $num_group < $count_group_tabs; $num_group++ ) { ?>

        <div class="ct11slide">
            <div class="ct11pagitem"><?php echo $num_group + 1; ?></div>
            <div class="ct14row ct14clear-a">
            
            <?php
            // Setup tren moi tabs
            $count_group_cur = count($group_tabs[$num_group]);
            for( $num_tabs = 0; $num_tabs < $count_group_cur; $num_tabs++ ) {
                $info_cur = $group_tabs[$num_group][$num_tabs];
                $id_cur = $info_cur['id'];
                $info_delete_cur = json_encode( array('id' => $id_cur, 'nonce' => $info_cur['nonce']) );
            ?>

            <div class="ct14col ct14col-2">
                <div class="ct14ga-item">
                    <a class="ct14ga-name" href="<?php echo 'admin.php?page=codetabs-edit&id='. $id_cur; ?>"><?php echo $info_cur['name']; ?></a>
                    <div class="ct14ga-info">

                        <span class="ct14ga-info-item ct14ga-id" title="Tabs id"># <?php echo $id_cur; ?></span>
                        <span class="ct14ga-info-item ct14ga-updated" title="Last updated"><?php echo $time_human[$id_cur]; ?> ago</span>
                        <a class="ct14ga-info-item ct14ga-duplicate" title="Duplicate tabs" href="admin.php?page=codetabs-create&amp;dup=<?php echo $id_cur; ?>"><i class="ct14i16-duplicate"></i></a>
                    </div>
                </div>
                
                <!-- Button item select -->
                <div class="ct14ga-select ct14tabs-btn-select" data-ct14info='<?php echo $info_delete_cur; ?>'></div>
            </div>
            <?php } ?>
            
            </div> <!-- Row - end -->
        </div> <!-- Slide tabs - end -->
        <?php } ?>
        
        </div> <!-- Tabs AllTabs - end -->
    </div> <!-- Container - end -->
    <!-- GALLERY ITEM WITH TABS - end -->
    <?php endif; ?>
        
        
    <!-- GALLERY ITEM + NEW TABS - begin -->
    <div class="ct14ga ct14container">
    <div class="ct14row">

        <?php if($is_onegroup) : ?>
            
            <!-- GALLERY ITEM NEU CHI CO 1 GROUP - begin -->
            <?php
            foreach($a_tabs as $id_cur => $info_cur) {
                $info_delete_cur = json_encode( array('id' => $id_cur, 'nonce' => $info_cur['nonce']) );
            ?>

            <div class="ct14col ct14col-2">
                <div class="ct14ga-item">
                    <a class="ct14ga-name" href="<?php echo 'admin.php?page=codetabs-edit&id='. $id_cur; ?>"><?php echo $info_cur['name']; ?></a>
                    <div class="ct14ga-info">

                        <span class="ct14ga-info-item ct14ga-id" title="Tabs id"># <?php echo $id_cur; ?></span>
                        <span class="ct14ga-info-item ct14ga-updated" title="Last updated"><?php echo $time_human[$id_cur]; ?> ago</span>
                        <a class="ct14ga-info-item ct14ga-duplicate" title="Duplicate tabs" href="admin.php?page=codetabs-create&amp;dup=<?php echo $id_cur; ?>"><i class="ct14i16-duplicate"></i></a>
                    </div>
                </div>
                
                <!-- Button item select -->
                <div class="ct14ga-select ct14tabs-btn-select" data-ct14info='<?php echo $info_delete_cur; ?>'></div>
            </div>

            <?php } ?>
            <!-- GALLERY ITEM NEU CHI CO 1 GROUP - end -->
        <?php endif; ?>
        
        <!-- ADD NEW TABS - begin -->
        <div class="ct14col ct14col-2 ct14ga-addnew-wrap">
        <a class="ct14ga-addnew" href="admin.php?page=codetabs-create">
            <div class="ct14ga-addnew-content">
                <div class="ct14ga-plus">+</div>
                <p>create new tabs</p>
            </div>

            <div class="ct14ga-deco ct14ga-deco-top"></div>
            <div class="ct14ga-deco ct14ga-deco-bottom"></div>
        </a>
        </div>
    </div>
    </div>
    <!-- GALLERY ITEM + NEW TABS - end -->
    <!-- GALLERY - end
    ////////////////////////////////////////////////////////////////////////// -->




    

    <!-- INLINE - begin
    ////////////////////////////////////////////////////////////////////////// -->
    <div style="display: none;">

        <!-- INLINE DELETE - begin
        ====================================================================== -->
        <div id="ct14id-delete" class="ct14id">
            <h1 class="ct14id-title">Confirm&nbsp;&hairsp;Delete</h1>
            
            <div class="ct14tabs-btn-ajax">
                <a  class="ct14tabs-btn ct14tabs-btn-first ct14tabs-confirm-delete ct14ip48-yes-color"
                    data-options='{ "parent": ".ct14tabs-btn-ajax" }'
                    >Delete</a>

                <a class="ct14tabs-btn ct14tabs-btn-first ct14box-close ct14ip48-no-color">Cancel</a>

                <span
                    class="ct14tabs-btn-last"
                    data-ct14svg='{"name": "loader-puff", "width": 55, "height": 55, "strokeWidth": 2, "color": "#dd0000" }'
                ></span>
            </div>
        </div>
        <!-- INLINE DELETE - end
        ====================================================================== -->

    </div>
    <!-- INLINE - end
    ////////////////////////////////////////////////////////////////////////// -->

</div>