<?php
/**
 * Part code of CodeTabs plugins
 * @name Shortcode
 */


/* SHORTCODE MAIN SETUP
----------------------------------------------------------------------------- */
/* KIEM TRA ID CUA TABS CO TON TAI HAY KHONG */
function ct14check_id_exists($tabs_id = NULL, $tabs_slug = NULL) {
    $opts_main    = get_option('codetabs');
    $opts_id      = $opts_main['id'];
    $is_ID_exists = false;
    


    // KIEM TRA ID - SLUG CODETABS CO TON TAI TRONG DATABASE HAY KHONG
    // Kiem tra Slug cua tabs truoc
    if( $tabs_slug != NULL ) {
        foreach( $opts_id as $i => $info_cur ) {
            if( $tabs_slug == $info_cur['slug'] ) {
                $tabs_id = $i;
                $is_ID_exists = true;
                break;
            }
        }
    }
    // Kiem tra id cua tabs
    else if( $tabs_id != NULL && array_key_exists($tabs_id, $opts_id) ) {
        $is_ID_exists = true;
    }

    // Tra ve ket qua? tim kiem
    return $is_ID_exists ? $tabs_id : false;
}



/* THAY DOI TEN SHORTCODE DE THUC HIEN SHORTCODE CODETABS NESTED */
function ct14shortcode_do_nested($tabs_nested, $content_html) {

    // Ho tro thuc hien shortcode codetabs nested bang cach thay 'codetabs' than`h codetabs_nested
    // Truong hop khong co tabs nested
    if( $tabs_nested == 0 ) {
        $pattern = '/\[\s*codetabs\s+/';
        $replace = '[codetabs_nested1 ';
    }
    // Tabs nested thu 1, 2, 3
    // Tang thu tu cua tabs nested
    else if( $tabs_nested > 0 && $tabs_nested < 3 ) {
        $pattern = '/\[codetabs_nested\d\s+/';
        $replace = '[codetabs_nested'. ($tabs_nested + 1 ) .' ';
    }
    // Truong hop con lai --> loai bo het shortcode tabs
    else {
        $pattern = '/\[\s*codetabs.*\]/';
        $replace = '';
    }

    // CHUA HOAN THIEN --> CAN SUA LAI
    // Tra ve html cua content
    return do_shortcode($content_html);
}



/* FUNCTION CO NHIEN VU RENDER HTML CUA CODETABS : DUNG CHUNG CHO SHORTCODE VA CODETABS FUNCTION */
function ct14render_codetabs($atts) {

    $html         = '';
    $opts_main    = get_option('codetabs');
    $opts_cur     = NULL;
    $tabs_id      = isset($atts['id']) ? $atts['id'] : NULL;
    $tabs_slug    = isset($atts['slug']) ? $atts['slug'] : NULL;
    $tabs_title   = isset($atts['title']) ? $atts['title'] : '';
    $tabs_class   = isset($atts['class']) ? $atts['class'] : '';
    $tabs_nested  = 0;
    $is_ID_exists = ct14check_id_exists($tabs_id, $tabs_slug);


    // Kiem tra ket ID co ton tai hay khong --> neu ID khong ton tai --> ket thuc render
    if( $is_ID_exists != false ) {
        $tabs_id  = $is_ID_exists;
        $opts_cur = get_option('ct14used_'. $tabs_id);

        // Tam thoi cap nhat lien tuc
        // $html_cur = $opts_cur['html'];
        $html_cur = NULL;
    }
    else return $html;


    // Kiem tra bien 'html' trong opt_cur --> neu co' thay' lay, khoi setup --> giup he thong lay' nhanh hon
    if( $html_cur == NULL ) {

        /* BIEN KHOI TAO VA SHORTCUT BAN DAU
        ----------------------------------------------------------------- */
        $contents   = $opts_cur['contents'];
        $slide_num  = (int) $opts_cur['info']['slideNum'];
        $slide_html = '';
        $jsData     = $opts_cur['jsData'];
        $css        = $opts_cur['css'];

        // Chen 'isAutoInit' vao jsData
        if( !isset($jsData['isAutoInit']) ) $jsData['isAutoInit'] = 1;

        $jsData   = json_encode($jsData);
        $cssClass = implode(' ', $opts_cur['cssClass']);
        $cssID    = 'ct11id-'. $tabs_id;

        // Setup ID cua tabs tren DOM
        $domID = (isset($css['domID']) && $css['domID'] != '') ? ('id="'. $css['domID'] .'" ') : '';


        // Render tat ca? cac SLIDE trong Tabs
        for( $i = 0; $i < $slide_num; $i++ ) {

            // Setup content cua slide
            // Ho tro thuc hien shortcode trong noi dung cua slide
            $content_html = html_entity_decode($contents[$i]['content']);
            $content_html = ct14shortcode_do_nested($tabs_nested, $content_html);

            // Ket noi noi dung cua slide voi nhau 
            $slide_html .=
            '<div>' .
                '<div class="ct11pagitem">'. html_entity_decode($contents[$i]['title']) .'</div>' .
                $content_html .
            '</div>';
        }






        /* STYLE INLINE TREN DOM
        ----------------------------------------------------------------- */
        $css_default   = $opts_main['css'];
        $skin_name     = $css['skin'];
        $css_inline    = "";

        // STYLE INLINE COLOR
        if( $skin_name != "" ) {
            $color_cur = $css['colorCur'];

            // Neu khac voi color default
            if( $color_cur != $opts_main['css']['colorDefault'] ) {

                // Lay Inline color options
                $inline_color = $css_default['inlineColor'][$skin_name];

                // Thay the 'color' va` 'idTabs' trong style inline
                $re = array('/\s+/', '/\$color/', '/\$idTabs/');
                $replace = array(" ", $color_cur, ".". $cssID .".". $skin_name);
                $css_inline .= preg_replace($re, $replace, $inline_color);
            }
        }

        // STYLE INLINE CUSTOM
        // Ket hop voi style inline truoc do'
        $inline_custom = $css['styleCustom'];
        if( $inline_custom != "" ) {
            $css_inline .= $inline_custom;
        }

        // KET HOP VOI HTML DOM
        if( $css_inline != "" ) {

            // Minify css don gian
            // Loai bo ghi chu
            $css_inline = preg_replace('!/\*[^*]*\*+([^/][^*]*\*+)*/!', '', $css_inline);
            // Loai bo nhieu khoang trang bang 1 khoang trang
            $css_inline = preg_replace('!\s+!', " ", $css_inline);
            // Loai bo nhieu khoang trang phan dau va` phan cuoi + xuo'ng don`g
            $css_inline = preg_replace(array('!(^\s+|\s+$)!'), "", $css_inline);
            // Loai bo cac khoang tra'ng khac
            $re = array('!\s*\{\s*!', '!\s*\}\s*!', '!\s*\;\s*!', '!\s*\:\s*!', '!\s*\>\s*!');
            $replace = array("{", "}", ";", ":", ">");
            $css_inline = preg_replace($re, $replace, $css_inline);

            // Chen` them style inline vao` html
            $html .= '<style type="text/css">'. $css_inline .'</style>';
        }







        /* HTML DOM TOAN BO
        ----------------------------------------------------------------- */
        // HTML MAIN TABS
        $html .=
        '<div '. $domID .'class="ct11 '. $cssID .' '. $cssClass .'" data-tabs='. $jsData .'>'.
            $slide_html .
        '</div>';

        // HTML TITLE : CHEN PHIA TRUOC MAIN TABS
        // Kiem tra co tags heading --> khoi wrap h2 heading
        if( $tabs_title != '' ) {
            $is_heading = preg_match('/(\&lt;|\<)h[1-6](\&gt|\>);/', $tabs_title);
            if( !$is_heading ) $tabs_title = '<h2 class="ct14title">'. $tabs_title .'</h2>';
        }

        // HTML WRAP
        $html = '<div class="ct14wrap '. $tabs_class . '">' . $tabs_title . $html .'</div>';


        // LUU TRU HTML VAO OPTIONS HIEN TAI
        // Luu tru trong database thi chuyen ki tu dau phay? sang ki tu Unicode het
        // Tam thoi loai luu tru 'html' tren database
        // $opts_cur['html'] = ct14to_unicode($html);
        update_option('ct14used_'. $tabs_id, $opts_cur);
    }

    // LAY HTML TRUC TIEP TU TRONG OPTIONS CURRENT NEU CO SAN
    else $html = $html_cur;

    // CUOI CUNG TRA LAI HTML
    // Convert lai thanh ki' tu HTML tu` ki' tu Unicode
    return html_entity_decode($html);
}


/* SHORTCODE : LAY HTML CODETABS BANG ID */
/**
 * Function lay noi dung cua shortcode
 * Function dang ki shortcode
 */
function ct14shortcode_codetabs($atts) {
    $atts['tabs_nested'] = 0;
    return ct14render_codetabs($atts);
}

function ct14register_shortcode() {
    add_shortcode('codetabs', 'ct14shortcode_codetabs');
}

add_action('init', 'ct14register_shortcode');









/* GET HTML CODETABS BY PHP FUNCTION
----------------------------------------------------------------------------- */
function codetabs($atts = NULL) {
    // Truong hop khong co tham so atts
    if( $atts == NULL ) return;

    // Truong hop atts la` ID/Slug cua tabs
    // Render tabs bang ID
    if( is_numeric($atts) ) $atts = array('id' => $atts);
    if( is_string($atts) )  $atts = array('slug' => $atts);

    // Truong hop atts la tap hop nhieu thong so
    if( is_array($atts) ) {

        // Thuoc tinh mac dinh
        // Thay the thuoc tinh' mac dinh bang thuoc tinh custom
        $atts_default = array(
            'id'        => NULL,
            'slug'      => NULL,
            'markup'    => 'main',

            // Only cho markup outside
            'outside_id'    => '',
            'outside_class' => ''
        );
        $atts   = array_replace_recursive($atts_default, $atts);
        $markup = $atts['markup'];

        
        // Neu la` markup main thi render markup body
        if( $markup == 'main' || $markup == NULL ) {
            echo ct14render_codetabs($atts);
        }

        // Neu la markup khac --> render thanh phan outside
        else if( in_array($markup, array('pag', 'nav', 'timer')) ) {
            
            // Tiep tuc kiem tra ID cua tabs co ton tai hay khong
            $tabs_id = ct14check_id_exists($atts['id'], $atts['slug']);
            if( $tabs_id != false ) {

                // Bien shortcut
                $outside_id     = $atts['outside_id'];
                $outside_class  = $atts['outside_class'];
                $domID          = $outside_id != '' ? "id='$outside_id'" : '';
                $data_tabs      = '{ "name" : "tabs-'. $tabs_id .'" }';

                // Render markup outside
                $html = "<div $domId class='ct11$markup $outside_class' data-tabs='". $data_tabs ."'></div>";
                echo $html;
            }
        }
    }
}