<?php
/**
 * Part code of CodeTabs plugins
 * @name Widget
 */


/* CODE WIDGET CLASS MAIN
----------------------------------------------------------------------------- */
class CodeTabs_Widget extends WP_widget {

    /**
     * Dang ki widget
     * Voi [ID widget, Name, Array options]
     */
    function __construct() {

        parent::__construct('codetabs_widget', 'CodeTabs Widget',array(
            'description' => 'Display a CodeTabs',
            'panels_icon' => 'icon ct14icon-codetabs'
        ));
    }

    /**
     * Hien thi widget
     */
    function widget($args, $instance) {

        // Dieu kien can co' la phai noi dung cua widget
        // Lay tabs id tu noi dung widget
        // Thuc hien shortcode codetabs thong qua id
        if( isset($instance['content']) && !empty($instance['content']) ) {
            $tabs_id = $instance['content'];
            $shortcode_cur = '[codetabs id="'. $tabs_id . '"]';

            // Render noi dung chinh' cua widget
            // Hook co' dinh can` phai thuc hien la`:
            // 'before_widget', 'after_widget', 'before_title', 'after_title'
            echo $args['before_widget'];

            // Kiem tra title cua widget
            // Setup title --> neu co thi` render title
            if( !empty($instance['title']) ) {

                $title = $args['before_title'];
                $title .= apply_filters('widget_title', $instance['title']);
                $title .= $args['after_title'];
                echo $title;
            }

            echo do_shortcode($shortcode_cur);
            echo $args['after_widget'];
        }
    }

    /**
     * Back-end widget form
     */
    function form($instance) {
        // Lay title co san trong database
        $title_content = !empty($instance['title']) ? $instance['title'] : '';

        // Render form html
        $title_id   = $this->get_field_id('title');
        $title_name = $this->get_field_name('title');
        $opts_main  = get_option('codetabs');
        $tabs_list  = $opts_main['id'];
        ?>

        <p>
            <label for="<?php echo $title_id; ?>">Title:</label>
            <input type="text" id="<?php echo $title_id; ?>" class="widefat" name="<?php echo $title_name; ?>" value="<?php echo $title_content; ?>">
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('content'); ?>">Select a Tabs:</label>
            <select id="<?php echo $this->get_field_id('content'); ?>" class="widefat" name="<?php echo $this->get_field_name('content'); ?>">

                <?php foreach( $tabs_list as $id_cur => $info_cur ) {
                    // Noi dung hien thi cu?a tung option select
                    $option_value = $info_cur['name'] . " [#". $id_cur ."]";
                ?>

                <option value="<?php echo $id_cur; ?>"><?php echo $option_value; ?></option>

                <?php } ?>
            </select>
        </p>

        <?php
    }

    /**
     * Cap nhat du~ lieu cua widget
     */
    function update($new_instance, $old_instance) {
        $instance = array();

        // Update tat cac doi tuong trong trong du~ lieu moi
        foreach ($new_instance as $name => $value) {
            $instance[$name] = !empty($name) ? $value : '';
        }

        // Tra lai du~ lieu moi
        return $instance;
    }
}

// Dang ki codetabs widget vao he thong
add_action('widgets_init', function() { register_widget('CodeTabs_Widget'); });





/* VISUAL COMPOSER
----------------------------------------------------------------------------- */
function ct14widget_visualcomposer() {

    /**
     * LUU TRU THONG TIN CUA TOAN BO CODETABS VAO ARRAY
     */
    $opts_main = get_option('codetabs');
    $arr_id    = $opts_main['id'];
    $arr_show  = array();

    foreach( $arr_id as $id => $info ) {
        // array_push($arr_show, $info['name'] .' #'. $info['id']);
        array_push($arr_show, array(
            'value'     => $info['id'],
            'text'      => $info['name'] .' #'. $info['id']
        ));
    }

    vc_map(array(
        'name'      => 'CodeTabs',
        'base'      => 'codetabs',
        'icon'      => plugins_url('imgs/icons/icon-logo-dark32.png', __FILE__),
        // 'custom_markup' => 'custom markup',
        'params'    => array(
            array(
                'type'          => 'textfield',
                'class'         => '',
                'heading'       => 'Title',
                'param_name'    => 'title',
                'value'         => '',
                'description'   => 'Title of tabs. Leave blank if no title is needed'
            ),
            array(
                'type'          => 'dropdown',
                'class'         => '',
                'heading'       => 'CodeTabs Shortcode',
                'param_name'    => 'id',
                'value'         => $arr_show,
                'description'   => 'Select tabs form list'
            ),
            array(
                'type'          => 'textfield',
                'class'         => '',
                'heading'       => 'Extra CSS Class Name',
                'param_name'    => 'class',
                'value'         => '',
                'description'   => 'Special css class for this tabs'
            )
        )
    ));
}

add_action( 'vc_before_init', 'ct14widget_visualcomposer' );