<?php
/**
 * CodeTabs WordPress Plugin
 * @package         CodeTabs
 * @author          20script
 * @link            http://www.20script.ir
 *
 *
 * Plugin Name:     CodeTabs
 * Plugin URI:      http://wp.thystudio.com/codetabs
 * Description:     CodeTabs is a great plug-in tabs when integrated gestrue swipe, move between slides really easy on desktop and mobile.
 * Version:         3.0.3
 * Author:          thystudio
 * Author URI:      thystudio.com
 * Tested up to:    4.2.2
 */




/**
 * CHECK FIRST!
 *  + Kiem tra plugin co chay trong wordpress -> kiem tra bien wpinc
 *  + Kiem tra wordpress co upgrading hay khong -> loai bo codetabs loading
 */
if( !defined('WPINC') ) die();
if( defined('WP_INSTALLING') && WP_INSTALLING ) return;






/**
 * DANG KI VA LOAI BO PLUGIN
 */
require_once('admin/options-init.php');
register_activation_hook(__FILE__, 'ct14_activation');
register_deactivation_hook(__FILE__, 'ct14_deactivation');






/**
 * ADD ADMIN MENU
 */
function ct14register_menu() {

    // Bien khoi tao va shortcut ban dau
    // Icon khong su dung image truc tiep --> su dung background-image trong css
    $icon_url   = '';
    $opts_main  = get_option('codetabs');
    $is_access  = current_user_can('access_codetabs');
    $capability = $is_access ? 'access_codetabs' : NULL;

    // Menu Main
    add_menu_page( 'CodeTabs', 'CodeTabs', $capability, 'codetabs', 'ct14page_main', $icon_url );

    // Menu Create New
    add_submenu_page( 'codetabs', 'CodeTabs Create', 'Add New', $capability, 'codetabs-create', 'ct14page_create' );

    // Menu Edit
    add_submenu_page( 'codetabs', 'CodeTabs Edit', 'Edit', $capability, 'codetabs-edit', 'ct14page_edit' );

    // Menu Hidden
    add_submenu_page( 'codetabs', 'CodeTabs Hidden', 'Options', $capability, 'codetabs-hidden', 'ct14page_hidden' );
}

function ct14page_main()      { require_once('admin/page-home.php'); }
function ct14page_create()    { require_once('admin/page-edit.php'); }
function ct14page_edit()      { require_once('admin/page-edit.php'); }
function ct14page_hidden()   { require_once('admin/page-hidden.php'); }

add_action('admin_menu', 'ct14register_menu');







/**
 * INSERT SCRIPTS & STYLES
 * Neu khong hien thi phien ban version thi verion bang NULL
 */
function ct14register_scripts() {

    // Bien khoi tao va shortcut ban dau
    $opts_main = get_option('codetabas');
    $version = $opts_main['info']['version'];

    wp_register_style('ct14css-core', plugins_url('/code/codetabs.css', __FILE__), array(), $version);
    wp_register_style('c00css-animate', plugins_url('/code/code.animate.css', __FILE__), array(), $version);
    wp_register_style('ct14css-admin', plugins_url('/admin/css/styles.css', __FILE__), array(), $version);
    wp_register_style('ct14css-globals', plugins_url('/admin/css/globals.css', __FILE__), array(), $version);

    wp_register_script('ct14js-header', plugins_url('/code/codetabs.js', __FILE__), array('jquery'), $version);
    wp_register_script('ct14js-footer', plugins_url('/code/codetabs.js', __FILE__), array('jquery'), $version, true);
    wp_register_script('ct14js-setup', plugins_url('/admin/js/codetabs.setup.js', __FILE__), array('jquery'), $version, true);
}

// CHEN STYLE + SCRIPT VAO TRANG ADMIN WORDPRESS
function ct14scripts_page_admin() {
    wp_enqueue_style('ct14css-globals');
}

// CHEN STYLE + SCRIPT VAO TRANG FRONTS CUA THEME 
function ct14scripts_page_front() {
    global $post;

    // Kiem tra doi tuong dc ke thua` cua class WP_Post
    // Kiem tra noi dung trong Post co chua shortcode hay khong
    // Kiem tra trong trang co' ton` tai. function 'codetabs' hay khong
    if( !(is_a($post, 'WP_Post') && (has_shortcode($post->post_content, 'codetabs') || function_exists('codetabs'))) ) return;

    // Script se~ chen` vao trong trang neu co' codetabs
    wp_enqueue_style('ct14css-core');
    wp_enqueue_style('c00css-animate');   // Kiem tra co' chen` hay khong
    wp_enqueue_script('ct14js-header');
}

// CHEN STYLE + SCRIPT VAO TRANG CODETABS SETUP
function ct14scripts_page_codetabs() {
    // Kiem tra codetabs co' chen` vao chua !!! quan trong --> tranh xung dot
    wp_enqueue_style('ct14css-core');
    wp_enqueue_style('c00css-animate');
    wp_enqueue_style('ct14css-admin');
    wp_enqueue_script('ct14js-footer');
    wp_enqueue_script('ct14js-setup');
}

add_action('init', 'ct14register_scripts');
add_action('admin_enqueue_scripts', 'ct14scripts_page_admin');
add_action('wp_enqueue_scripts', 'ct14scripts_page_front', 11);
add_action('load-' . 'toplevel_page_codetabs', 'ct14scripts_page_codetabs', 11);
add_action('load-' . 'codetabs_page_codetabs-create', 'ct14scripts_page_codetabs', 11);
add_action('load-' . 'codetabs_page_codetabs-edit', 'ct14scripts_page_codetabs', 11);
add_action('load-' . 'codetabs_page_codetabs-hidden', 'ct14scripts_page_codetabs', 11);






/**
 * SHORTCODE + WIDGET
 */
require_once('admin/shortcode.php');
require_once('admin/widget.php');






/**
 * EDITOR TINYMCE CUSTOM
 */
function ct14mce_setup_custom() {

    // Kiem tra quye`n han toi thieu la` 'Editor'
    if( !current_user_can('edit_posts') && !current_user_can('edit_pages') ) return;

    // Kiem tra edit WYSIWYG duoc bat (so voi 'true')
    if( get_user_option('rich_editing') == 'true' ) {
        // Chen button 'codetabs' vao` editor tinymce
        add_filter('mce_external_plugins', 'ct14mce_add_plugin');
        add_filter('mce_buttons', 'ct14mce_add_button');

        // Setup custum chi tren trang codetabs
        if( isset($GLOBALS['plugin_page']) && !!preg_match('/(^codetabs)/', $GLOBALS['plugin_page']) ) {
            // Tat chuc nang spellcheck tren textarea
            add_filter('the_editor', 'ct14mce_filter_the_editor');
        }
    }
}

// Dang ki thuoc tinh button codetabs bang Javascript
function ct14mce_add_plugin($plugin_array) {
    $plugin_array['ct14btn_codetabs'] = plugins_url('/admin/js/codetabs.button.js', __FILE__);
    return $plugin_array;
}

// Chen` ten button codetabs vao` he tho'ng button cua editor
function ct14mce_add_button($buttons) {
    array_push($buttons, 'ct14btn_codetabs');
    return $buttons;
}

// Tat chuc nang spellcheck tren textarea
function ct14mce_filter_the_editor($editor_wrap) {
    $re = '/autocomplete="off"/';
    $replace = 'spellcheck="false" autocomplete="off" autocorrect="off" autocapitalize="off"';
    return preg_replace($re, $replace, $editor_wrap);
}

/* CHEN BIEN JAVASCRIPT CUSTOM TRUOC TINYMCE INIT */
function ct14mce_add_custom_script($hook) {

    // Chi chen tren trang 'post.php' va 'post-new.php' (bao gom 'posts' va 'pages') + ca'c trang codetabs
    if( !!preg_match('/(^post|codetabs)/', $hook) ) {
        $opts_main = get_option('codetabs'); ?>
        

        <script type="text/javascript" class="ct14script-value">
            // Chen` tat ca tabs_id vao` bien globals ct14VA
            if( !window.ct14VA ) window.ct14VA = {};
            window.ct14VA['tabsID'] = <?php echo json_encode( $opts_main['id'] ); ?>;
        </script>


    <?php }
}

add_action('admin_head', 'ct14mce_setup_custom');
add_action('admin_enqueue_scripts', 'ct14mce_add_custom_script');










/**
 * FUNCTION OTHERS
 */
function ct14message_html( $class_type = '', $message ) {

    // Setup html
    $html = '<div class="ct-message '. $class_type .'">'. $message .'</div>';
    echo $html;
}


/* AJAX REQUEST */
require_once('admin/ajax.php');


/* REDIRECT URL : KIEM TRA URL */
function ct14redirect_home() {

    // Kiem tra co phai trang codetabs-edit
    if( isset($_GET['page']) && $_GET['page'] == 'codetabs-edit' ) {

        // Function redirect toi trang chu
        $redirect = function() {
            $url = admin_url('admin.php?page=codetabs');
            header("Location: $url");
            exit();
        };

        // Tiep tuc kiem tra cac truong hop
        // Truong hop co' id va` khong co' id
        if( isset($_GET['id']) ) {
            $get_id    = $_GET['id'];
            $opts_main = get_option('codetabs');

            // Kiem tra ID trong url co' to`n tai trong database hay khong
            if( !array_key_exists($get_id, $opts_main['id']) ) $redirect();
        }
        else $redirect();
    }
}
add_action('init', 'ct14redirect_home');


/* ESCAPE : CHUYEN DOI KI TU DAC BIEN SANG KI TU UNICODE */
function ct14to_unicode($str) {
    $pattern = array('/\"/', '/\'/');
    $replace = array('&#34;', '&#39;');

    return preg_replace($pattern, $replace, $str);
}